/**
 * Copyright (c) 2006-2012 ʯſƼ޹˾
 * All rights reserved.
 *
 * @brief 򿪵һӵļ豸ʾʹmd5 .
 *
 * @version 2.0
 */

#include "stdafx.h"
#include <malloc.h>
#include <memory.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>

#include "common.h"
#include "inc/sample_16.h"
/**< ִļϢ */
#define ET_EXE_FILE_ID		"0001"
#define ET_EXE_FILE_PATH	"hardware\\sample_16_hw.bin"

/**< Ŀ¼Ϣ */
#define ET_SUB_DIRNAME		"0016"
#define SUB_DEV_PIN			"876543218765432187654321"
#define SUB_USR_PIN			"87654321"
#define SUB_SIZE			3000

/**< */
int main(int argc, char* argv[]) {

    ET_CONTEXT pContextList[250] = {0} ;	//豸б
    ET_CONTEXT * pCtx = NULL;   

    DWORD dwDeviceNumber = 0;					//ӵ豸
    DWORD dwResult  = 0;

    unsigned char lpSubName[] = ET_SUB_DIRNAME ;
    DWORD dwSubSize = SUB_SIZE ;
    DWORD dwBytesReturned = 0 ;

    BYTE  plaintext1[ 100 ] 	= "this is the test data" ;
    BYTE  plaintext2[ 100 ] 	= "this is a nother test data" ;
    WORD wIOSize = 0  ;
    int i ;
    	/**< ʼ豸б */
    dwDeviceNumber = 250 ;
	dwResult = ETEnum( pContextList , &dwDeviceNumber) ;
	if( 0 != dwResult ){
		printf("Enumerate device failed! <error code: 0x%08x>\n", dwResult);
                printf( "\nPress any key to continue...\n"  );
		while ( !kbhit( ) );
		return -1 ;
	}
	
    /**<  򿪵һ豸  */
    pCtx = pContextList +0 ;
    dwResult = ETOpen( pCtx );
    if (0 != dwResult) {
        printf("ETOpen for first device failed with error code:%d\n", dwResult);
        goto FINAL_EXIT;
    }


      /**< Ŀ¼֤Ŀ¼DEV_PIN */
    printf("Create sub directory [%s] ..... \n" , lpSubName ) ;
    dwResult = createSubdirAtRoot( pCtx , (const char *)lpSubName , dwSubSize , SUB_DEV_PIN , SUB_USR_PIN ,  0xFF , 0xFF ) ;
    if ( dwResult != 0 )  goto FINAL_EXIT ;
    
	dwResult = ETVerifyPin( pCtx , (unsigned char*)SUB_DEV_PIN , ET_DEV_PIN_LEN, ET_DEV_PIN);
    if ( dwResult != 0 ) {
        printf("Verify the sub directory [%s] DEV_PIN  failed! <error code: 0x%08x>\n", lpSubName , dwResult);
        goto FINAL_EXIT ;
    }
     /**< Ŀ¼´ļ */
    printf("Write hex file to  device....\n");
    dwResult = loadFileIntoDevice( pCtx , ET_EXE_FILE_ID , FILE_TYPE_EXE , ET_EXE_FILE_PATH );
    if (dwResult != 0 ) {
        printf("Write file to device failed! <error code: 0x%08x>\n",dwResult);
        goto FINAL_EXIT ;
    }

     /**< ûȨ  */
    dwResult = ETVerifyPin( pCtx , (unsigned char *)SUB_USR_PIN , ET_USER_PIN_LEN ,  ET_USER_PIN);
    if (dwResult != 0) {
        printf("Verify USER_PIN failed! <error code: 0x%08x>\n",dwResult);
        goto FINAL_EXIT ;
    }

    /**< ִص豸еļ  */
    printf("\n\nExecute program in device...\n");

    IO_CONTEXT	ioContext ;

    /**< md5 ʼ */
    printf("MD5 init .....\n");
    ioContext.bTag = CMD_MD5_INIT ;
    dwBytesReturned = 0 ;
    wIOSize = sizeof(IO_CONTEXT)  ;
    dwResult =ETExecute( pCtx , ET_EXE_FILE_ID,  &ioContext,  wIOSize , &ioContext , wIOSize , &dwBytesReturned);
    if (dwResult != 0) {
        printf("Execute program in device failed! <error code: 0x%08x>\n",dwResult);
        goto FINAL_EXIT;
    }

    if (  ioContext.bTag != 0 ) {
       printf("*internal* error in device failed! <error code: 0x%08x>\n",ioContext.bTag);
       goto FINAL_EXIT;
    }

    /**< md5 1*/
    ioContext.bTag = CMD_MD5_UPDATE ;
    ioContext.bDataLen = strlen( (char *)plaintext1 ) ;
    strcpy( (char*)ioContext.pbData , (char*)plaintext1  ) ;

    wIOSize = sizeof(IO_CONTEXT) ;
    dwResult =ETExecute( pCtx , ET_EXE_FILE_ID,  &ioContext,  wIOSize , &ioContext , wIOSize , &dwBytesReturned);
    if (dwResult != 0) {
        printf("Execute program1 in device failed! <error code: 0x%08x>\n",dwResult);
       goto FINAL_EXIT;
    }

    if (  ioContext.bTag != 0 ) {
        printf("*internal* error in device failed! <error code: 0x%08x>\n",ioContext.bTag);
        goto FINAL_EXIT;
    }
    /**< md5 2*/
    ioContext.bTag = CMD_MD5_UPDATE ;
    ioContext.bDataLen = strlen( (char *)plaintext2 ) ;
    strcpy( (char*)ioContext.pbData , (char*)plaintext2  ) ;

    wIOSize = sizeof(IO_CONTEXT) ;
    dwResult =ETExecute( pCtx , ET_EXE_FILE_ID,  &ioContext,  wIOSize , &ioContext , wIOSize , &dwBytesReturned);
    if (dwResult != 0) {
        printf("Execute program2 in device failed! <error code: 0x%08x>\n",dwResult);
       goto FINAL_EXIT;
    }

    if (  ioContext.bTag != 0 ) {
        printf("*internal* error in device failed! <error code: 0x%08x>\n",ioContext.bTag);
       goto FINAL_EXIT;
    }

    /**< md5  */
    ioContext.bTag = CMD_MD5_FINAL ;
    wIOSize = sizeof(IO_CONTEXT) ;
    dwResult =ETExecute( pCtx , ET_EXE_FILE_ID,  &ioContext,  wIOSize , &ioContext , wIOSize , &dwBytesReturned);
    if (dwResult != 0) {
        printf("Execute program3 in device failed! <error code: 0x%08x>\n",dwResult);
       goto FINAL_EXIT;
    }

    if (  ioContext.bTag != 0 ) {
        printf("*internal* error3 in device failed! <error code: 0x%08x>\n",ioContext.bTag);
       goto FINAL_EXIT;
    }

    printf("The MD5 final text ! \n");
    for (  i = 0 ; i < ioContext.bDataLen ; i++ ) {
        printf("%.2X " , ioContext.pbData[i]);
    }
    printf("\n");

FINAL_EXIT:

    /**< ر豸 */
    dwResult = ETClose( pCtx );

   	printf( "\nPress any key to continue...\n"  );
    while ( !kbhit( ) );
    return 0 ;

}


