/**
 * Copyright (c) 2006-2012 ʯſƼ޹˾
 * All rights reserved.
 *
 * @brief оӵü豸ǵġDevice_ATR
 *
 * @version 2.0
 */


#include "stdafx.h"
#include <malloc.h>
#include <memory.h>
#include <stdio.h>
#include <conio.h>


#include "ET199_32.h"

/**< */
int main(int argc, char* argv[]) {

    ET_CONTEXT pContextList[250] = {0} ;	//豸б
    ET_CONTEXT * pCtx = NULL;   

    DWORD dwDeviceNumber = 0;					//ӵ豸
    DWORD dwResult  = 0;

    /**< ʼ豸б */
    dwDeviceNumber = 250 ;
	dwResult = ETEnum( pContextList , &dwDeviceNumber) ;
	if( 0 != dwResult ){
		printf("Enumerate device failed! <error code: 0x%08x>\n", dwResult);
        return -1;
	}
	

    for ( int i = 0 ; i < (int)dwDeviceNumber ; i ++ ) {
        char lpDeviceID[ MAX_ID_LEN + 1] ;
        sprintf( lpDeviceID , "NEWID_%.2d" , i ) ;

        printf("Set up device atr  [%s] for device %d \n", lpDeviceID , i );
        /**<  豸  */
        pCtx = pContextList + i ;
        dwResult = ETOpen( pCtx );
        if (0 != dwResult) {
            printf("ETOpen for device NO : %d failed with error code:%d\n", i ,dwResult);
            continue;
        }

        dwResult = ETChangeDir( pCtx , "\\");
        if (dwResult != 0 ) {
            printf("Change root directory for device NO : %d failed! <error code: 0x%08x>\n", i ,dwResult);
            ETClose( pCtx ) ;
            continue;
        }

        /**< ֤PIN  */
        dwResult = ETVerifyPin( pCtx , ET_DEFAULT_DEV_PIN , ET_DEV_PIN_LEN , ET_DEV_PIN);
        if (0 != dwResult) {
            printf("Verify Pin for device No. %d failed! <error code: 0x%08x\n",i,dwResult);
            ETClose( pCtx ) ;
			continue;
        }
		/**< "DEVICE_ATR"*/
        dwResult = ETControl( pCtx , ET_SET_DEVICE_ATR, lpDeviceID, MAX_ID_LEN , NULL, 0, NULL);
        if (0 != dwResult) {
            printf("ETControl set device ATR for device No. %d failed! <error code: 0x%08x\n",i,dwResult);
            ETClose( pCtx ) ;
			continue;
        }
       
		/**< ر豸 */
        dwResult = ETClose( pCtx );
    }
   
	printf( "\nPress any key to continue...\n"  );
    while ( !kbhit( ) );
    return 0 ;

}


