#ifndef __SAMPLE_06_H__
#define __SAMPLE_06_H__

/**
 * By default, program compiled at PC has the address alignment issues which don't exist in C51 environment.
 * For convenience of data-handling,we use the compact-pack mode for storing the	exchanging data-buffer 
 * used between PC and ET199 device.
 */
#ifdef _WIN32
#pragma pack(push, 1)
typedef double DOUBLE;
#endif 

/**< IN package */
typedef struct _IN_PACKAGE
{	
    BYTE bVal;
    WORD wVal;
    DWORD dwVal;
    WORD  iVal;
    long lVal ;
	float fVal ;
    DOUBLE dVal;
    unsigned char buff[20];
} IN_PACKAGE;


/**< OUT_PACKAGE*/
typedef struct _OUT_PACKAGE
{	
    BYTE bVal;
    WORD wVal;
    DWORD dwVal;
    WORD  iVal;
    long lVal ;
	float fVal ;
    DOUBLE dVal;
    unsigned char buff[20];
 } OUT_PACKAGE;

#ifdef _WIN32
#pragma pack(pop)
#endif


#endif //__SAMPLE_06_H__