#include <stdio.h>
#include <string.h>
#include "../../common/et199.h"
#include "../inc/sample_14.h"

#define KEY_PUB_ID		0x0001
#define KEY_PRI_ID		0x0002
#define KEY_LEN			1024

#define SIGN_MODE		RSA_SIGN_NOPH
#define VERIFY_MODE		RSA_VERI_NOPKCS

#define ENC_MODE		RSA_CALC_PKCS
#define DEC_MODE		RSA_CALC_PKCS


IO_CONTEXT *  xdata  pIOContext  = NULL ;
BYTE xdata bRetcode = 0 ;
main()
{
    pIOContext   = ( IO_CONTEXT *  ) pbInBuff ;
	_swap(&pIOContext->wDataLen , sizeof(WORD) ) ;

    switch( pIOContext -> bTag )
    {
    case CMD_RSA_GEN :
        bRetcode  =  _rsa_gen_key(KEY_PUB_ID , KEY_PRI_ID  ,  KEY_LEN ) ; //Կļ
        break;
   
    case CMD_RSA_SIGN:
		pIOContext->wDataLen = 20 ;
        bRetcode  =  _rsa_sign( SIGN_MODE , KEY_PRI_ID , pIOContext->wDataLen , pIOContext->pbData) ;
        pIOContext->wDataLen = 128;
	    break;
    case CMD_RSA_VERIFY :
        bRetcode  =  _rsa_verify( RSA_VERI_NOPKCS , KEY_PUB_ID , pIOContext->wDataLen , pIOContext->pbData ) ;
        break;
   
    case CMD_RSA_ENC:
        bRetcode  =  _rsa_enc( ENC_MODE  ,KEY_PUB_ID  ,  pIOContext->wDataLen , pIOContext->pbData) ;
        pIOContext->wDataLen = 128;
	    break;
    case CMD_RSA_DEC:
        bRetcode  =  _rsa_dec( DEC_MODE , KEY_PRI_ID , pIOContext->wDataLen , pIOContext->pbData) ;
		if(  bRetcode == 0 ){
			pIOContext->wDataLen = pIOContext->pbData [ 0 ] ;
			memcpy( &pIOContext->pbData [ 0 ] , &pIOContext->pbData [ 1 ] , pIOContext->wDataLen ) ;	
		}
        
		
        break ;
    }

	pIOContext->bTag = bRetcode ;
	_swap(&pIOContext->wDataLen , sizeof(WORD) ) ;
	_set_response(  sizeof ( IO_CONTEXT )  ,  pIOContext  );
    /**< exit the program */
    _exit();

}
